#include <iostream>
#include <fstream>
#include <math.h>
//#include "hash.h"

struct Patch{
  unsigned int r,g,b;
  unsigned int hash_value;
  int cont;
  int visitado;
  //int imagen;
  Patch *next;
  Patch();
  //bool operator==(const Patch *der) const;
  //bool operator!=(const Patch *der) const;
};

class hash{
 public:
  Patch **table;
  int tableSize;//, numElem;
 //public:
  hash(int size);
  ~hash();
  void insertar(Patch *patch);
  bool buscar(Patch *patch, int *count, int i)const;
  int getSize()const{return tableSize;}


  double get_load_factor() const;
  double get_standard_desviation() const;
  void get_histogram();

};

class Image{
 public:
  Patch *datas;
  hash *tabla;
  unsigned int *vector;
  int f, c, n_patch;
  unsigned int *distancias;
  Image();
  ~Image();
  void constructor(std::ifstream &fich_in, int w, int C);
  void crear_hash(int w, int C);
  void leer_fichero(std::ifstream &fich_in, int w, int C);
  void crear_patchs(int w);
  void vector_dist(int n_imagenes);
  bool buscar(Patch *patch, int *count, int i);
};

unsigned int hash_function(Patch *patch);

unsigned int hash_division(Patch *patch);

unsigned int hash_juanma(Patch *patch);

unsigned int DJBHash(Patch *patch);
