#include <iostream>
#include <fstream>
#include <math.h>
#include <queue>
//#include "hash.h"

using namespace std;

struct nodo_contador{
  int cont;
  int imagen;
  nodo_contador *next;
};

struct Patch{
  unsigned int r,g,b;
  //unsigned int hash_value;
  nodo_contador *contador;
  //int cont;
  //int visitado;
  //int valor;
  //int imagen;
  Patch *next;
  Patch();
  //bool operator==(const Patch *der) const;
  //bool operator!=(const Patch *der) const;
};

class hash{
 public:
  Patch **table;
  Patch *num_patch;
  nodo_contador *num_nodos_patch;
  int cuenta_patch, cuenta_nodos_patch;
  //Patch *patches;
  //int indice=0;
  int tableSize;//, numElem;
 //public:
  hash(int size);
  ~hash();
  //int num_patch, num_nodos_patch;
  void insertar(Patch *patch, int indice, int n_imagenes, queue <int> &cola, int &suma);
  //bool buscar(Patch *patch, int *count, int i)const;
  //int getSize()const{return tableSize;}

  
  double get_load_factor() const;
  double get_standard_desviation() const;
  void get_histogram();

};

class Image{
 public:
  Patch *datas;
  //hash *tabla;
  unsigned int *vector;
  int f, c, n_patch;
  unsigned int *distancias;
  int suma;
  Image();
  ~Image();
  void constructor(std::ifstream &fich_in, int w, int C, hash *tabla, int indice, int n_imagenes, queue <int> &cola);
  void insertar_hash(hash *tabla, int indice, int n_imagenes, queue <int> &cola, int &suma);
  //void crear_hash(int w, int C);
  void leer_fichero(std::ifstream &fich_in, int w, int C);
  void crear_patchs(int w);
  void vector_dist(int n_imagenes);
  //bool buscar(Patch *patch, int *count, int i);
};

unsigned int hash_function(Patch *patch);

unsigned int hash_division(Patch *patch);

unsigned int hash_juanma(Patch *patch);

inline unsigned int DJBHash(Patch *patch);
