#include "patch.h"

Patch::Patch(){
  r=g=b=cont=0;
  next=0;
  visitado=-1;
}
/*
bool Patch::operator==(const Patch *der) const{
  if(r != der->r || g != der->g || b != der->b) return false;
  return true;
}

bool Patch::operator!=(const Patch *der) const{
  if(r != der->r || g != der->g || b != der->b) return true;
  return false;
  }*/

//---------------Image---------------//

Image::Image(){}
Image::~Image(){}

void Image::leer_fichero(std::ifstream &fich_in, int w, int C){//, unsigned char *vector){
  char buffer[5];
 
  fich_in >> buffer;
  fich_in >> c;
  fich_in >> f;
  fich_in >> buffer;
  //printf("f: %d\tc: %d\n", f, c);
  int wh=c*3*f;
  vector = new unsigned int[wh];
  //unsigned int leer;
  
  for(int i=0;i<wh;++i){
    //fich_in >> leer;
    fich_in >> vector[i];
    //leer/=C;
    //vector[i] = leer;
    vector[i]/=C;
    //std::cout << i << ": " << (int)vector[i] << std::endl;
  }
}

void Image::crear_patchs(int w){
  /*int *pos_patch, ww=w*w;
  int salto=(c-w+1), dif=(c-salto)*3;
  n_patch = (f-w+1)*salto;
  pos_patch = new int[ww];
  datas = new Patch[n_patch]; // creo el vector de patch'es
  for(int i=0,u=0,mw=0;i<ww;++i){ // creo las posiciones de los patch a sumar
    if(mw==w){
      mw=0;
      u+=dif;
    }
    pos_patch[i]=u;
    u+=3;
    mw++;
  }
  for(int i=0;i<ww;++i) std::cout << pos_patch[i] << " "; // muestro las posiciones iniciales
  std::cout << "\n\n";
  for(int i=0,mw=0;i<n_patch;++i){
    for(int j=0;j<ww;++j){
      if(mw==salto)  // ESTA PARTE REVISARLA!!!!!!!!!!!!!!!!!!!!!!!!!! if(mw==w) ó if(mw==salto);
	pos_patch[j] = pos_patch[j]+dif;
      datas[i].r += (int)vector[pos_patch[j]];
      datas[i].g += (int)vector[pos_patch[j]+1];
      datas[i].b += (int)vector[pos_patch[j]+2];
      pos_patch[j]=pos_patch[j]+3;
    }
    if(mw==salto) mw=0;
    mw++;
  }
  */
  int alto=(f-w+1), ancho=(c-w+1);
  n_patch=alto*ancho;
  datas = new Patch[n_patch]; // creo el vector de patch'es
  for(int i=0;i<alto;++i){
    for(int j=0;j<ancho;++j){
      for(int ki=0;ki<w;++ki){
	for(int kj=0;kj<w;++kj){
	  datas[i*ancho+j].r+=vector[(i+ki)*c*3+(j+kj)*3];
	  datas[i*ancho+j].g+=vector[(i+ki)*c*3+(j+kj)*3+1];
	  datas[i*ancho+j].b+=vector[(i+ki)*c*3+(j+kj)*3+2];
	}
      }
    }
  }
  
  /*for(int i=0;i<n_patch;++i){
    std::cout << "patch" << i << " (";
    std::cout << datas[i].r << ", " << datas[i].g << ", " << datas[i].b << ")" << std::endl;
  }*/
  
}

void Image::constructor(std::ifstream &fich_in, int w, int C){
  leer_fichero(fich_in, w, C);  
  crear_patchs(w);
  crear_hash(w, C);
}

void Image::crear_hash(int w, int C){
  int size = w*w*765/C;
  //int size = w*w*(100*255+10*255+255)/C;
  tabla = new hash(size);
  for(int i=0;i<n_patch;++i){
    tabla->insertar(&datas[i]);
  }
  /*for(int i=0;i<size;++i){
    Patch *aux=tabla->table[i];
    while(aux){
      std::cout << "(" << aux->r << ", " << aux->g << ", " << aux->b << ") -> " << aux->cont << std::endl;
      aux=aux->next;
    }
    }*/
  //double desviation=tabla->get_standard_desviation();
  //std::cout << desviation << std::endl;
  //tabla->get_histogram();
  
}

void Image::vector_dist(int n_imagenes){
  distancias = new unsigned int[n_imagenes];
  for(int i=0;i<n_imagenes;++i)
    distancias[i]=0;
}

bool Image::buscar(Patch *patch, int *count, int i){
  return tabla->buscar(patch, count, i);
}

//-------------------TablaHash-------------------//

hash::hash(int size){
  tableSize = size;
  table = new Patch*[tableSize];
  for(int i=0;i<tableSize;++i) table[i]=0;
}

hash::~hash(){
  for(int i=0;i<tableSize;++i){
    Patch *aux=table[i], *borrar;
    while(aux){
      borrar=aux;
      aux=aux->next;
      delete borrar;
    }
  }
  delete [] table;
}

void hash::insertar(Patch *patch){
  //unsigned int hash_valor = hash_function(patch);
  //unsigned int hash_pos = hash_function(patch);//hash_valor % tableSize;
  unsigned int hash_func = DJBHash(patch);
  unsigned int hash_pos = hash_func%tableSize;
  bool seguir=1;
  if(table[hash_pos]==0){
    table[hash_pos] = patch;
    patch->cont++;
    patch->hash_value = hash_pos;
  }
  else{
    Patch *aux = table[hash_pos];
    while(aux && seguir){
      if(patch->r == aux->r && patch->g == aux->g && patch->b == aux->b){
        aux->cont++;
        seguir=0;
      }
      else if(aux->next==0){
	aux->next = patch;
	patch->cont++;
        aux = aux->next;
	seguir=0;
        patch->hash_value = hash_pos;
      }
      else aux=aux->next;
    }
  }
}

bool hash::buscar(Patch *patch, int *count, int i)const{
  //unsigned int hash_pos = hash_function(patch);
  //unsigned int hash_func = hash_division(patch);
  //unsigned int hash_pos = hash_func%tableSize;
  unsigned int hash_pos = patch->hash_value;
  Patch *aux=table[hash_pos];
  while(aux){
    if(aux->r == patch->r && aux->g == patch->g && aux->b == patch->b){
      aux->visitado=i;
      *count=aux->cont;
      return true;
    }
    aux=aux->next;
  }
  return false;
}


double hash::get_load_factor() const{
  int numElem=0;
  for(int i=0;i<tableSize;++i){
    Patch *aux=table[i];
    while(aux){
      aux=aux->next;
      ++numElem;
    }
  }
  return numElem/tableSize;
}

double hash::get_standard_desviation() const{
  double sum=0.0, sum_total=0.0, factor_de_carga;
  int num;
  factor_de_carga = get_load_factor();
  for(int i=0;i<tableSize;i++){
    num=0;
    sum=0.0;
    Patch *aux;
    aux=table[i];
    while(aux){
      num++;
      aux=aux->next;
    }
    sum= num-factor_de_carga;
    sum=pow(sum, 2);
    sum_total+=sum;
  }
  return sqrt(sum_total/(tableSize-1));
}

void hash::get_histogram(){
  //std::ofstream fich("histogram");
  //if(!fich) std::cout << "Mal, muy mal!!\n";
  int max=-1, *num_cubetas = new int[tableSize];
  for (int i=0;i<tableSize;i++) num_cubetas[i]=0;
  for(int i=0;i<tableSize;i++){
    Patch *aux=table[i];
    while(aux){
      aux = aux->next;
      num_cubetas[i]++;
    }
    if(num_cubetas[i]>max) max=num_cubetas[i];
  }
  //delete [] num_cubetas;
  int *histograma = new int[max+1];
  for(int i=0;i<tableSize;i++) histograma[i]=0;
  for(int i=0;i<tableSize;i++) histograma[num_cubetas[i]]++;
  //std::cout << max << std::endl;
  for(int i=0;i<max+1;i++) std::cout << i << " " << histograma[i] << std::endl;
  //fich.close();
  //delete [] histograma;
}


unsigned int hash_function(Patch *patch){
  return (patch->r + patch->g + patch->b);
}

unsigned int hash_division(Patch *patch) {
  const unsigned int rangChar  = 255;
  const unsigned int base      = rangChar;
  
  unsigned int h=0;
  h = (h*base + patch->r);
  h = (h*base + patch->g);
  h = (h*base + patch->b);
  return h;
}

unsigned int hash_juanma(Patch *patch){
  return (100*(patch->r)+10*(patch->g)+patch->b);
}

unsigned int DJBHash(Patch *patch){
  unsigned int hash = 5381;
  /*for(std::size_t i = 0; i < str.length(); i++){
    hash = ((hash << 5) + hash) + str[i];
  }*/
  
  hash = ((hash << 5) + hash) + patch->r;
  hash = ((hash << 5) + hash) + patch->g;
  hash = ((hash << 5) + hash) + patch->b;
  
  return hash;
}
