#include <iostream>
#include <fstream>
#include <math.h>
#include <queue>

using namespace std;

struct nodo_contador{
  int cont;
  int imagen;
  nodo_contador *next;
};

struct Patch{
  unsigned int r,g,b;
  nodo_contador *contador;
  Patch *next;
  Patch();
};

class hash{
 public:
  Patch **table;
  Patch *num_patch;
  nodo_contador *num_nodos_patch;
  int cuenta_patch, cuenta_nodos_patch;
  int tableSize;
  hash(int size);
  ~hash();
  void insertar(Patch *patch, int indice, int n_imagenes, queue <int> &cola, int &suma);
  
  double get_load_factor() const;
  double get_standard_desviation() const;
  void get_histogram();

};

class Image{
 public:
  Patch *datas;
  unsigned int *vector;
  int f, c, n_patch;
  unsigned int *distancias;
  int suma;
  Image();
  ~Image();
  void constructor(std::ifstream &fich_in, int w, int C, hash *tabla, int indice, int n_imagenes, queue <int> &cola);
  void insertar_hash(hash *tabla, int indice, int n_imagenes, queue <int> &cola, int &suma);
  void leer_fichero(std::ifstream &fich_in, int w, int C);
  void crear_patchs(int w);
  void vector_dist(int n_imagenes);
};

inline unsigned int DJBHash(Patch *patch);
